Comments in EJ2 JavaScript Document editor control

3 May 20258 minutes to read

Document Editor allows you to add comments to documents. You can add, navigate and remove comments in code and from the UI.

Add a new comment

Comments can be inserted to the selected text.

//Add new commnt in the document.
documentEditor.editor.insertComment('Test comment');

Add a New Comment with Date, Author, and Status

Comments can be inserted into the selected text with a specified date, author, and status insertComment.

  • TS
  • // In this example, a comment with the text "Hello world"
    // is added by the author Nancy Davolio on July 23, 2024, at 2:30 PM. 
    // The isResolved status is set to false.
    
    // Create a specific date: July 23, 2024, at 2:30:00 PM.
    // Note: July is represented by 6 (0-based index).
    var specificDate = new Date(2024, 6, 23, 14, 30, 0);
    
    // Define the properties of the comment including author, date, and resolution status.
    var commentProperties = { 
        author: 'Nancy Davolio',          // The author of the comment.
        dateTime: specificDate,           // The date and time when the comment is created.
        isResolved: false                 // The status of the comment; false indicates it is unresolved.
    };
    
    // Insert the comment with the specified properties into the document editor.
    documentEditor.editor.insertComment('Hello world', commentProperties);

    Add a Reply Comment with Date, Author, and Status

    Reply comments can be inserted into the parent comment with a specified date, author using insertReplyComment.

  • TS
  • // In this example, a comment with the text "Hello world"
    // is added by the author Nancy Davolio on July 23, 2024, at 2:30 PM. 
    // The isResolved status is set to false.
    
    // Create a specific date: July 23, 2024, at 2:30:00 PM.
    // Note: July is represented by 6 (0-based index).
    var specificDate = new Date(2024, 6, 23, 14, 30, 0);
    
    // Define the properties of the comment including author, date, and resolution status.
    var commentProperties = { 
        author: 'Nancy Davolio',          // The author of the comment.
        dateTime: specificDate,           // The date and time when the comment is created.
        isResolved: false                 // The status of the comment; false indicates it is unresolved.
    };
    
    // Insert the comment with the specified properties into the document editor.
    var comment = documentEditor.editor.insertComment('Hello world', commentProperties);
    // Insert a reply comment with specified properties into the Document Editor
    documentEditor.editor.insertReplyComment(comment.id, 'Hello world', commentProperties);

    Get Comments

    Document Editor allows to get the comments along with its reply and comment properties using getComments.

  • TS
  • //Get Comments in the document along with the properties author, date, status.
    var commentInfo = container.documentEditor.getComments();

    Comment navigation

    Next and previous comments can be navigated using the below code snippet.

    //Navigate to next comment
    documentEditor.selection.navigateNextComment();
    
    //Navigate to previous comment
    documentEditor.selection.navigatePreviousComment();

    Delete comment

    Current comment can be be deleted using deleteComment.

  • TS
  • //Delete the current selected comment.
    container.documentEditor.editor.deleteComment();
    
    //Get Comments in the document along with the properties author, date, status.
    var commentinfo = container.documentEditor.getComments();
    
    //Delete the particular parent comments and all of its reply comments
    container.documentEditor.editor.deleteComment(commentinfo[0].id);
    
    //Delete the particular reply comment.
    container.documentEditor.editor.deleteComment(commentinfo[0].replies[0].id);

    Delete all comment

    All the comments in the document can be deleted using the below code snippet.

    //Delete all the comments present in the current document.
    documentEditor.editor.deleteAllComments();

    Protect the document in comments only mode

    Document Editor provides support for protecting the document with CommentsOnly protection. In this protection, user allowed to add or edit comments alone in the document.

    Document editor provides an option to protect and unprotect document using enforceProtection and stopProtection API.

    The following example code illustrates how to enforce and stop protection in Document editor container.

    let container: DocumentEditorContainer = new DocumentEditorContainer({
      enableToolbar: true,
      height: '590px',
    });
    DocumentEditorContainer.Inject(Toolbar);
    container.serviceUrl =
      'http://localhost:5000/api/documenteditor/';
    container.appendTo('#container');
    
    //enforce protection
    container.documentEditor.editor.enforceProtection('123', 'CommentsOnly');
    
    //stop the document protection
    container.documentEditor.editor.stopProtection('123');

    Comment only protection can be enabled in UI by using Restrict Editing pane

    Enable comment only protection

    Note: In enforce Protection method, first parameter denotes password and second parameter denotes protection type. Possible values of protection type are NoProtection |ReadOnly |FormFieldsOnly |CommentsOnly. In stop protection method, parameter denotes the password.

    Mention Support in comments

    Mention support displays a list of items that users can select or tag from the suggested list. To use this feature, type the @ character in the comment box and select or tag the user from the suggestion list.

    The following example illustrates how to enable mention support in Document Editor

    let mentionData: any = [
        { "Name": "Mary Kate", "EmailId": "marry@company.com" },
        { "Name": "Andrew James", "EmailId": "james@company.com" },
        { "Name": "Andrew Fuller", "EmailId": "andrew@company.com"}
    ];
    let container: DocumentEditorContainer = new DocumentEditorContainer({ enableToolbar: true,height: '590px',
    // Enable mention support in document editor
      documentEditorSettings: {
        mentionSettings: { dataSource: mentionData, fields: { text: 'Name' }},
      }
    });
    DocumentEditorContainer.Inject(Toolbar);
    container.serviceUrl = 'https://services.syncfusion.com/js/production/api/documenteditor/';
    container.appendTo('#container');

    The Web API hosted link https://services.syncfusion.com/js/production/api/documenteditor/ utilized in the Document Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

    Events

    DocumentEditor provides beforeCommentAction event, which is triggered on comment actions like Post, edit, reply, resolve and reopen. This event provides an opportunity to perform custom logic on comment actions like Post, edit, reply, resolve and reopen. The event handler receives the CommentActionEventArgs object as an argument, which allows access to information about the comment.

    To demonstrate a specific use case, let’s consider an example where we want to restrict the delete functionality based on the author’s name. The following code snippet illustrates how to allow only the author of a comment to delete:

    var mentionData = [
        { "Name": "Mary Kate", "EmailId": "marry@company.com" },
        { "Name": "Andrew James", "EmailId": "james@company.com" },
        { "Name": "Andrew Fuller", "EmailId": "andrew@company.com"}
        ];
        // Initialize DocumentEditorContainer component.
        var documenteditorContainer = new ej.documenteditor.DocumentEditorContainer({ enableToolbar: true, height: '590px', beforeCommentAction:beforecomment,documentEditorSettings: {
        mentionSettings: { dataSource: mentionData, fields: { text: 'Name' }},
      } });
        ej.documenteditor.DocumentEditorContainer.Inject(ej.documenteditor.Toolbar);
        documenteditorContainer.serviceUrl = 'http://localhost:6028/api/documenteditor/';
        //DocumentEditorContainer control rendering starts
        documenteditorContainer.appendTo('#DocumentEditor');
        documenteditorContainer.currentUser = "Guest User";
    
    
        // Event get triggerd on comment actions like Post, edit, reply, resolve and reopen
        function beforecomment(args){
          // Check the type and author of the comment and current user are different
          if(args.type === "Delete" && documenteditorContainer.currentUser !== args.author){
            // Cancel the comment action
            args.cancel = true;
          }
        }

    The Web API hosted link https://services.syncfusion.com/js/production/api/documenteditor/ utilized in the Document Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

Comments in Vue Document editor component

3 May 202513 minutes to read

Document Editor allows you to add comments to documents. You can add, navigate and remove comments in code and from the UI.

Add a new comment

Comments can be inserted to the selected text.

this.$refs.documenteditor.ej2Instances.editor.insertComment('Test comment');

Add a New Comment with Date, Author, and Status

Comments can be inserted into the selected text with a specified date, author, and status insertComment.

// In this example, a comment with the text "Hello world"
// is added by the author Nancy Davolio on July 23, 2024, at 2:30 PM. 
// The isResolved status is set to false.

// Create a specific date: July 23, 2024, at 2:30:00 PM.
// Note: July is represented by 6 (0-based index).
let specificDate = new Date(2024, 6, 23, 14, 30, 0); 

// Define the properties of the comment including author, date, and resolution status.
let commentProperties: CommentProperties = { 
    author: 'Nancy Davolio',          // The author of the comment.
    dateTime: specificDate,           // The date and time when the comment is created.
    isResolved: false                 // The status of the comment; false indicates it is unresolved.
};

// Insert the comment with the specified properties into the document editor.
this.$refs.documenteditor.ej2Instances.editor.insertComment('Hello world', commentProperties);

Add a Reply Comment with Date, Author, and Status

Reply comments can be inserted into the parent comment with a specified date, author using insertReplyComment.

// In this example, a comment with the text "Hello world"
// is added by the author Nancy Davolio on July 23, 2024, at 2:30 PM. 
// The isResolved status is set to false.

// Create a specific date: July 23, 2024, at 2:30:00 PM.
// Note: July is represented by 6 (0-based index).
let specificDate = new Date(2024, 6, 23, 14, 30, 0); 

// Define the properties of the comment including author, date, and resolution status.
let commentProperties: CommentProperties = { 
    author: 'Nancy Davolio',          // The author of the comment.
    dateTime: specificDate,           // The date and time when the comment is created.
    isResolved: false                 // The status of the comment; false indicates it is unresolved.
};

// Insert the comment with the specified properties into the document editor.
let comment: Comment = this.$refs.documenteditor.ej2Instances.editor.insertComment('Hello world', commentProperties);
// Insert a reply comment with specified properties into the Document Editor
this.$refs.documenteditor.ej2Instances.editor.insertReplyComment(comment.id, 'Hello world', commentProperties);

Get Comments

Document Editor allows to get the comments along with its reply and comment properties using getComments.

//Get Comments in the document along with the properties author, date, status.
let commentinfo: CommentInfo[] = this.$refs.container.ej2Instances.documentEditor.getComments();

Comment navigation

Next and previous comments can be navigated using the below code snippet.

//Navigate to next comment
this.$refs.documenteditor.ej2Instances.selection.navigateNextComment();

//Navigate to previous comment
this.$refs.documenteditor.ej2Instances.selection.navigatePreviousComment();

Delete comment

Current comment can be deleted using deleteComment.

//Delete the current selected comment.
this.$refs.container.ej2Instances.documentEditor.editor.deleteComment();

//Get Comments in the document along with the properties author, date, status.
let commentinfo: CommentInfo[] = this.$refs.container.ej2Instances.documentEditor.getComments();

//Delete the particular parent comments and all of its reply comments
this.$refs.container.ej2Instances.documentEditor.editor.deleteComment(commentinfo[0].id);

//Delete the particular reply comment.
this.$refs.container.ej2Instances.documentEditor.editor.deleteComment(commentinfo[0].replies[0].id);

Delete all comment

All the comments in the document can be deleted using the below code snippet.

this.$refs.documenteditor.ej2Instances.editor.deleteAllComments();

Protect the document in comments only mode

Document Editor provides support for protecting the document with CommentsOnly protection. In this protection, user allowed to add or edit comments alone in the document.

Document editor provides an option to protect and unprotect document using enforceProtection and stopProtection API.

The following example code illustrates how to enforce and stop protection in Document editor container.

<template>
  <div id="app">
    <ejs-documenteditorcontainer ref='container' :serviceUrl='serviceUrl' height="590px" id='container'
      :enableToolbar='true'>
    </ejs-documenteditorcontainer>
  </div>
</template>
<script setup>
import { onMounted, ref, provide } from 'vue';
import { DocumentEditorContainerComponent as EjsDocumenteditorcontainer, Toolbar } from '@syncfusion/ej2-vue-documenteditor';

const container = ref(null);
const serviceUrl = 'https://services.syncfusion.com/vue/production/api/documenteditor/';

provide('DocumentEditorContainer', [Toolbar]);

onMounted(function () {
  //enforce protection
  container.value.ej2Instances.documentEditor.editor.enforceProtection('123', 'CommentsOnly');
  //stop the document protection
  container.value.ej2Instances.documentEditor.editor.stopProtection('123');
})

</script>
<template>
  <div id="app">
    <ejs-documenteditorcontainer ref='container' :serviceUrl='serviceUrl' height="590px" id='container'
      :enableToolbar='true'>
    </ejs-documenteditorcontainer>
  </div>
</template>
<script>
import { DocumentEditorContainerComponent, Toolbar } from '@syncfusion/ej2-vue-documenteditor';

export default {
  components: {
    'ejs-documenteditorcontainer': DocumentEditorContainerComponent
  },
  data() {
    return { serviceUrl: 'https://services.syncfusion.com/vue/production/api/documenteditor/' };
  },
  provide: {//Inject require modules.
    DocumentEditorContainer: [Toolbar]
  },
  mounted() {
    //enforce protection
    this.$refs.container.ej2Instances.documentEditor.editor.enforceProtection('123', 'CommentsOnly');
    //stop the document protection
    this.$refs.container.ej2Instances.documentEditor.editor.stopProtection('123');
  }
}
</script>

The Web API hosted link https://services.syncfusion.com/vue/production/api/documenteditor/ utilized in the Document Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

Comment only protection can be enabled in UI by using Restrict Editing pane

Enable comment only protection

Note: In enforce Protection method, first parameter denotes password and second parameter denotes protection type. Possible values of protection type are NoProtection |ReadOnly |FormFieldsOnly |CommentsOnly. In stop protection method, parameter denotes the password.

Mention support in Comments

Mention support displays a list of items that users can select or tag from the suggested list. To use this feature, type the @ character in the comment box and select or tag the user from the suggestion list.

The following example illustrates how to enable mention support in the Document Editor

<template>
    <div id="app">
      <ejs-documenteditorcontainer ref='documenteditor' :serviceUrl='serviceUrl' :documentEditorSettings='settings' height="590px" id='container' :enableToolbar='true'></ejs-documenteditorcontainer>
    </div>
</template>
<script>
  import Vue from 'vue';
  import { DocumentEditorContainerPlugin, DocumentEditorContainerComponent,Toolbar} from '@syncfusion/ej2-vue-documenteditor';
  Vue.use(DocumentEditorContainerPlugin);
  let mentionData =  [
                { "Name": "Mary Kate", "EmailId": "marry@company.com" },
                { "Name": "Andrew James", "EmailId": "james@company.com" },
                { "Name": "Andrew Fuller", "EmailId": "andrew@company.com"}
            ];
  export default {
    data() {
      return { serviceUrl:'https://services.syncfusion.com/vue/production/api/documenteditor/',
      settings: { mentionSettings: { dataSource: mentionData, fields: { text: 'Name' }} }},
    },
    provide: {
      //Inject require modules.
      DocumentEditorContainer: [Toolbar]
    }
  }
</script>

The Web API hosted link https://services.syncfusion.com/vue/production/api/documenteditor/ utilized in the Document Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

Events

DocumentEditor provides beforeCommentAction event, which is triggered on comment actions like Post, edit, reply, resolve and reopen. This event provides an opportunity to perform custom logic on comment actions like Post, edit, reply, resolve and reopen. The event handler receives the CommentActionEventArgs object as an argument, which allows access to information about the comment.

To demonstrate a specific use case, let’s consider an example where we want to restrict the delete functionality based on the author’s name. The following code snippet illustrates how to allow only the author of a comment to delete:

<template>
  <div id="app">
    <ejs-documenteditorcontainer ref="container" height="590px" :toolbarItems='items' :documentEditorSettings="settings" :beforeCommentAction="beforeComment"
      :enableToolbar='true' :currentUser="'Guest User'" > </ejs-documenteditorcontainer>
  </div>
</template>

<script setup>
import { DocumentEditorContainerComponent as EjsDocumenteditorcontainer, Toolbar } from '@syncfusion/ej2-vue-documenteditor';
import { provide, ref } from 'vue';

const container = ref(null);
let mentionData =  [
                { "Name": "Mary Kate", "EmailId": "marry@company.com" },
                { "Name": "Andrew James", "EmailId": "james@company.com" },
                { "Name": "Andrew Fuller", "EmailId": "andrew@company.com"}
            ];
provide('DocumentEditorContainer', [Toolbar]);
const settings= { mentionSettings: { dataSource: mentionData, fields: { text: 'Name' }} };
const beforeComment = function (args) {
  if(args.type === "Delete" && container.value.ej2Instances.currentUser !== args.author){
    args.cancel = true;
  }
}
</script>

<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/material.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/material.css';
@import "../node_modules/@syncfusion/ej2-documenteditor/styles/material.css";
</style>
<template>
  <div id="app">
    <ejs-documenteditorcontainer ref="container" height="590px" :beforeCommentAction="beforeComment"
      :enableToolbar='true' :documentEditorSettings="settings" :currentUser="'Guest User'" ></ejs-documenteditorcontainer>
  </div>
</template>

<script>
import { DocumentEditorContainerComponent, Toolbar } from '@syncfusion/ej2-vue-documenteditor';
let mentionData =  [
                { "Name": "Mary Kate", "EmailId": "marry@company.com" },
                { "Name": "Andrew James", "EmailId": "james@company.com" },
                { "Name": "Andrew Fuller", "EmailId": "andrew@company.com"}
            ];
export default {
  components: {
    'ejs-documenteditorcontainer': DocumentEditorContainerComponent
  },
  data() {
    return {
      settings: { mentionSettings: { dataSource: mentionData, fields: { text: 'Name' }} }
    }
  },
  provide: {
    DocumentEditorContainer: [Toolbar]
  },
  methods: {
    beforeComment: function (args) {
      if(args.type === "Delete" && this.$refs.container.currentUser !== args.author){
        args.cancel=true;
      }
    }
  }
}
</script>

<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/material.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/material.css';
@import "../node_modules/@syncfusion/ej2-documenteditor/styles/material.css";
</style>

Comments in Angular Document editor component

20 Dec 20222 minutes to read

Document Editor allows you to add comments to documents. You can add, navigate and remove comments in code and from the UI.

Add a new comment

Comments can be inserted to the selected text.

this.documentEditor.editor.insertComment("Test comment");

Comment navigation

Next and previous comments can be navigated using the below code snippet.

//Navigate to next comment
this.documentEditor.selection.navigateNextComment();

//Navigate to previous comment
this.documentEditor.selection.navigatePreviousComment();

Delete comment

Current comment can be be deleted using the below code snippet.

this.documentEditor.editor.deleteComment();

Delete all comment

All the comments in the document can be deleted using the below code snippet.

this.documentEditor.editor.deleteAllComments();

Protect the document in comments only mode

Document Editor provides support for protecting the document with CommentsOnly protection. In this protection, user allowed to add or edit comments alone in the document.

Document editor provides an option to protect and unprotect document using enforceProtection and stopProtection API.

The following example code illustrates how to enforce and stop protection in Document editor container.

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DocumentEditorContainerComponent, ToolbarService } from '@syncfusion/ej2-angular-documenteditor';

@Component({
      selector: 'app-container',
      // specifies the template string for the Document Editor component
      template: `<div><button ejs-button (click)="protectDocument()" >Protect</button>
      <button ejs-button (click)="unProtectDocument()" >Unprotect</button>
      <ejs-documenteditorcontainer #document_editor serviceUrl="https://ej2services.syncfusion.com/production/web-services/api/documenteditor/" height="600px" style="display:block" [enableToolbar]=true> </ejs-documenteditorcontainer></div>`,
      encapsulation: ViewEncapsulation.None,
      providers: [ToolbarService]
})
export class AppComponent {
    @ViewChild('document_editor')
    public container: DocumentEditorContainerComponent;

    public protectDocument(): void {
        //enforce protection
        container.documentEditor.editor.enforceProtection('123', 'CommentsOnly');
    }

    public unProtectDocument(): void {
        //stop the document protection
        container.documentEditor.editor.stopProtection('123');
    }
}

Comment only protection can be enabled in UI by using Restrict Editing pane

Enable comment only protection

Note: In enforce Protection method, first parameter denotes password and second parameter denotes protection type. Possible values of protection type are NoProtection |ReadOnly |FormFieldsOnly |CommentsOnly. In stop protection method, parameter denotes the password.

Comments in React Document editor component

3 May 202513 minutes to read

Document Editor allows you to add comments to documents. You can add, navigate and remove comments in code and from the UI.

To know more about the comments in DocumentEditor component, you can check the video below.

Add a new comment

Comments can be inserted to the selected text.

documentEditor.editor.insertComment('Test comment');

Add a New Comment with Date, Author, and Status

Comments can be inserted into the selected text with a specified date, author, and status insertComment.

// In this example, a comment with the text "Hello world"
// is added by the author Nancy Davolio on July 23, 2024, at 2:30 PM. 
// The isResolved status is set to false.

// Create a specific date: July 23, 2024, at 2:30:00 PM.
// Note: July is represented by 6 (0-based index).
let specificDate = new Date(2024, 6, 23, 14, 30, 0); 

// Define the properties of the comment including author, date, and resolution status.
let commentProperties: CommentProperties = { 
    author: 'Nancy Davolio',          // The author of the comment.
    dateTime: specificDate,           // The date and time when the comment is created.
    isResolved: false                 // The status of the comment; false indicates it is unresolved.
};

// Insert the comment with the specified properties into the document editor.
documentEditor.editor.insertComment('Hello world', commentProperties);

Add a Reply Comment with Date, Author, and Status

Reply comments can be inserted into the parent comment with a specified date, author using insertReplyComment.

// In this example, a comment with the text "Hello world"
// is added by the author Nancy Davolio on July 23, 2024, at 2:30 PM. 
// The isResolved status is set to false.

// Create a specific date: July 23, 2024, at 2:30:00 PM.
// Note: July is represented by 6 (0-based index).
let specificDate = new Date(2024, 6, 23, 14, 30, 0); 

// Define the properties of the comment including author, date, and resolution status.
let commentProperties: CommentProperties = { 
    author: 'Nancy Davolio',          // The author of the comment.
    dateTime: specificDate,           // The date and time when the comment is created.
    isResolved: false                 // The status of the comment; false indicates it is unresolved.
};

// Insert the comment with the specified properties into the Document Editor.
let comment: Comment = documentEditor.editor.insertComment('Hello world', commentProperties);
// Insert a reply comment with specified properties into the Document Editor
documentEditor.editor.insertReplyComment(comment.id, 'Hello world', commentProperties);

Get Comments

Document Editor allows to get the comments along with its reply and comment properties using getComments.

//Get Comments in the document along with the properties author, date, status.
let commentinfo: CommentInfo[] = container.documentEditor.getComments();

Comment navigation

Next and previous comments can be navigated using the below code snippet.

//Navigate to next comment
documentEditor.selection.navigateNextComment();

//Navigate to previous comment
documentEditor.selection.navigatePreviousComment();

Delete comment

Current comment can be deleted using deleteComment.

//Delete the current selected comment.
container.documentEditor.editor.deleteComment();

//Get Comments in the document along with the properties author, date, status.
let commentinfo: CommentInfo[] = container.documentEditor.getComments();

//Delete the particular parent comments and all of its reply comments
container.documentEditor.editor.deleteComment(commentinfo[0].id);

//Delete the particular reply comment.
container.documentEditor.editor.deleteComment(commentinfo[0].replies[0].id);

Delete all comment

All the comments in the document can be deleted using the below code snippet.

documentEditor.editor.deleteAllComments();

Protect the document in comments only mode

Document Editor provides support for protecting the document with CommentsOnly protection. In this protection, user allowed to add or edit comments alone in the document.

Document editor provides an option to protect and unprotect document using enforceProtection and stopProtection API.

The following example code illustrates how to enforce and stop protection in Document editor container.

import { createRoot } from 'react-dom/client';
import * as React from 'react';
import {
  DocumentEditorContainerComponent,
  Toolbar,
} from '@syncfusion/ej2-react-documenteditor';
DocumentEditorContainerComponent.Inject(Toolbar);
function App() {
  let container = DocumentEditorContainerComponent;
  function enforceProtection() {
    //enforce protection
    container.documentEditor.editor.enforceProtection('123', 'CommentsOnly');
  }
  function stopProtection() {
    //stop the document protection
    container.documentEditor.editor.stopProtection('123');
  }
  return (
    <div>
      <button onClick={enforceProtection}>Enforce Protection</button>
      <button onClick={stopProtection}>Stop Protection</button>
      <DocumentEditorContainerComponent
        id="container"
        ref={(scope) => {
          container = scope;
        }}
        height={'590px'}
        serviceUrl="https://services.syncfusion.com/react/production/api/documenteditor/"
        enableToolbar={true}
      />
    </div>
  );
}
export default App;
createRoot(document.getElementById('sample')).render(<App />);

The Web API hosted link https://services.syncfusion.com/react/production/api/documenteditor/ utilized in the Document Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

Comment only protection can be enabled in UI by using Restrict Editing pane

Enable comment only protection

Note: In enforce Protection method, first parameter denotes password and second parameter denotes protection type. Possible values of protection type are NoProtection |ReadOnly |FormFieldsOnly |CommentsOnly. In stop protection method, parameter denotes the password.

Mention support in Comments

Mention support displays a list of items that users can select or tag from the suggested list. To use this feature, type the @ character in the comment box and select or tag the user from the suggestion list.

The following example illustrates how to enable mention support in the Document Editor

import { createRoot } from 'react-dom/client';
import * as React from 'react';
import {
  DocumentEditorContainerComponent,
  Toolbar,
} from '@syncfusion/ej2-react-documenteditor';
DocumentEditorContainerComponent.Inject(Toolbar);
function App() {
  let container = DocumentEditorContainerComponent;
  let mentionData = [
    { Name: 'Mary Kate', EmailId: 'marry@company.com' },
    { Name: 'Andrew James', EmailId: 'james@company.com' },
    { Name: 'Andrew Fuller', EmailId: 'andrew@company.com' },
  ];
  let settings = {
    showRuler: true,
    mentionSettings: { dataSource: mentionData, fields: { text: 'Name' } },
  };
  return (
    <div>
      <DocumentEditorContainerComponent
        id="container"
        ref={(scope) => {
          container = scope;
        }}
        height={'590px'}
        serviceUrl="https://services.syncfusion.com/react/production/api/documenteditor/"
        enableToolbar={true}
        documentEditorSettings={settings}
      />
    </div>
  );
}
export default App;
createRoot(document.getElementById('sample')).render(<App />);

The Web API hosted link https://services.syncfusion.com/react/production/api/documenteditor/ utilized in the Document Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.

Events

DocumentEditor provides beforeCommentAction event, which is triggered on comment actions like Post, edit, reply, resolve and reopen. This event provides an opportunity to perform custom logic on comment actions like Post, edit, reply, resolve and reopen. The event handler receives the CommentActionEventArgs object as an argument, which allows access to information about the comment.

To demonstrate a specific use case, let’s consider an example where we want to restrict the delete functionality based on the author’s name. The following code snippet illustrates how to allow only the author of a comment to delete:

import { createRoot } from 'react-dom/client';
import * as React from 'react';
import { useEffect, useRef } from 'react';

import {
  DocumentEditorContainerComponent,
  Toolbar,
} from '@syncfusion/ej2-react-documenteditor';

DocumentEditorContainerComponent.Inject(Toolbar);
// tslint:disable:max-line-length
const Default = () => {
  useEffect(() => {}, []);
  let hostUrl: string =
    'https://ej2services.syncfusion.com/production/web-services/api/documenteditor/';
  let container: DocumentEditorContainerComponent = useRef(null);
  let mentionData = [
    { Name: 'Mary Kate', EmailId: 'marry@company.com' },
    { Name: 'Andrew James', EmailId: 'james@company.com' },
    { Name: 'Andrew Fuller', EmailId: 'andrew@company.com' },
  ];
  let settings = {
    showRuler: true,
    mentionSettings: { dataSource: mentionData, fields: { text: 'Name' } },
  };

  // Event get triggerd on comment actions like Post, edit, reply, resolve and reopen
  function beforeComment(args: CommentActionEventArgs) {
    // Check the type and author of the comment and current user are different
    if (
      args.type === 'Delete' &&
      container.current.currentUser !== args.author
    ) {
      // Cancel the comment action
      args.cancel = true;
    }
  }
  return (
    <div className="control-pane">
      <div className="control-section">
        <div id="documenteditor_titlebar" className="e-de-ctn-title"></div>
        <div id="documenteditor_container_body">
          <DocumentEditorContainerComponent
            id="container"
            ref={container}
            style=
            height={'590px'}
            serviceUrl={hostUrl}
            enableToolbar={true}
            documentEditorSettings={settings}
            beforeCommentAction={beforeComment}
            currentUser="Guest User"
            locale="en-US"
          />
        </div>
      </div>
    </div>
  );
};
export default Default;

const root = createRoot(document.getElementById('sample'));
root.render(<Default />);

The Web API hosted link https://services.syncfusion.com/react/production/api/documenteditor/ utilized in the Document Editor’s serviceUrl property is intended solely for demonstration and evaluation purposes. For production deployment, please host your own web service with your required server configurations. You can refer and reuse the GitHub Web Service example or Docker image for hosting your own web service and use for the serviceUrl property.